import noise
import json
from random import randint

dic = [[[[0 for i in range(20)] for j in range(20)]for k in range(20)]for l in range(20)]

with open("biomes.json", "r", encoding="utf-8") as json_file:
    biomes = json.load(json_file)

def getBiome(humidity,temperature,height, wierdness):
    dis = 10000
    nea = biomes["biomes"][0]
    i = 0
    j = 0
    for biome in biomes["biomes"]:
        nd = (((biome["temperature"]-temperature)**2+(biome["humidity"]-humidity)**2+(biome["height"]-height)**2+(biome["wierdness"]-wierdness))**2)**0.5/4
        
        if dis > nd:
            nea = biome
            dis = nd
            j = i
        i += 1
    return nea

def load():
    for h in range(0,20):
        for t in range(0,20):
            for j in range(0,20):
                for w in range(0,20):
                    dic[h][t][j][w] = getBiome(((h-10)/10),((t-10)/10),((j-10)/10),((w-10)/10))
    print("biomes loaded")
    
btx = randint(0, 1024)
btz = randint(0, 1024)

bhx = randint(0, 1024)
bhz = randint(0, 1024)

blx = randint(0, 1024)
blz = randint(0, 1024)

btx = randint(0, 1024)
btz = randint(0, 1024)

sfxx = randint(0, 1024)
sfxz = randint(0, 1024)

sfzx = randint(0, 1024)
sfzz = randint(0, 1024)

seedHeightX = [randint(0, 1024) for i in biomes["octaves"]]
seedHeightZ = [randint(0, 1024) for i in biomes["octaves"]]

load()
biomeCache = {}
def getBiome(x, z):
    name = str(x)+"_"+str(z)
    if (name in biomeCache):
        return biomeCache[name]
    
    x = x/200
    z = z/200
    temp = int(min(20,max(0,noise.pnoise2(btx+x, btz+z)*10+10)))
    hum = int(min(20,max(0,noise.pnoise2(bhx+x, bhz+z)*10+10)))
    lvl = int(min(20,max(0,noise.pnoise2(blx+x, blz+z)*10+10)))
    wierd = int(min(20,max(0,noise.pnoise2(blx+x, blz+z)*10+10)))
    
    biomeCache[name] = dic[hum][temp][lvl][wierd]
    
    return biomeCache[name]

def getXShiftFix(x, y, z):
    biome = getBiome(x,z)
    return noise.pnoise2(sfxx+y/20, sfxz+z/20)*biome["shift"]

def getZShiftFix(x, y, z):
    biome = getBiome(x,z)
    return noise.pnoise2(sfzx+y/20, sfzz+x/20)*biome["shift"]

def areaMean(x,y,z,dx,dy,dz,func):
    v = 0
    nb = 0
    for i in range(-dx,dx+1):
        for j in range(-dy,dy+1):
            for k in range(-dy,dy+1):
                v += func(x+i,y+j,z+k)
                nb+=1
    return v/nb
                
def getXShift(x,y,z):
    return areaMean(x,y,z,1,0,1,getXShiftFix)

def getZShift(x,y,z):
    return areaMean(x,y,z,1,0,1,getZShiftFix)

def getHeightPerlinFix(x,y,z,octave):
    return noise.pnoise2(seedHeightX[octave]+x/20, seedHeightX[octave]+z/20)

def getHeightPerlinOctavedFix(x,y,z):
    v = 0
    o = 0
    i = 0
    for octave in biomes["octaves"]:
        v += getHeightPerlinFix(x,y,z,i)*octave
        o += octave
        i += 1
    return v/o

def getHeightFix(x,y,z):
    s = (getHeightPerlinOctavedFix(x,y,z)+1)/2
    biome = getBiome(x,z)
    
    return biome["minLevel"] + (biome["maxLevel"]-biome["minLevel"])*s

def getHeight(x,y,z):
    sx = x#+getXShift(x,y,z)
    sz = z#+getXShift(x,y,z)
    return areaMean(sx,y,sz,1,0,1,getHeightFix)

def hasBlock(x,y,z,decorator = None):
    v = getHeight(x,y,z)
    if decorator != None:
        v = decorator(x,y,z,v)
    return y < v

